# Generated by Django 5.0 on 2024-04-09 17:57

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("comments", "0010_remove_comment_content_old"),
        ("posts", "0031_postsave_postsave_user_post_save"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="UserNotification",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("message", models.TextField()),
                (
                    "notification_type",
                    models.CharField(
                        choices=[("web", "Web Notification")], max_length=10
                    ),
                ),
                (
                    "category",
                    models.CharField(
                        choices=[
                            ("mentions", "Упоминания"),
                            ("invite", "Приглашение"),
                            ("update", "Обновления"),
                            ("events", "События"),
                            ("service", "Сервисные"),
                            ("moderation", "Модерация"),
                            ("user_events", "События пользователя"),
                        ],
                        max_length=20,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("viewed_at", models.DateTimeField(blank=True, null=True)),
                (
                    "comment",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="affected_comment",
                        to="comments.comment",
                    ),
                ),
                (
                    "post",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="affected_post",
                        to="posts.post",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="recipient",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.AddConstraint(
            model_name="usernotification",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(
                        models.Q(
                            ("category__in", ["mentions", "user_events"]), _negated=True
                        ),
                        ("user__isnull", False),
                        _connector="OR",
                    )
                ),
                name="user_required_for_mentions_and_user_events",
            ),
        ),
    ]
